/*----- PROTECTED REGION ID(TestMemoryLeakClass.h) ENABLED START -----*/
//=============================================================================
//
// file :        TestMemoryLeakClass.h
//
// description : Include for the TestMemoryLeak root class.
//               This class is the singleton class for
//                the TestMemoryLeak device class.
//               It contains all properties and methods which the 
//               TestMemoryLeak requires only once e.g. the commands.
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef TestMemoryLeakClass_H
#define TestMemoryLeakClass_H

#include <tango.h>
#include <TestMemoryLeak.h>


/*----- PROTECTED REGION END -----*/	//	TestMemoryLeakClass.h


namespace TestMemoryLeak_ns
{
/*----- PROTECTED REGION ID(TestMemoryLeakClass::classes for dynamic creation) ENABLED START -----*/


/*----- PROTECTED REGION END -----*/	//	TestMemoryLeakClass::classes for dynamic creation

//=========================================
//	Define classes for attributes
//=========================================
//	Attribute speed class definition
class speedAttrib: public Tango::Attr
{
public:
	speedAttrib():Attr("speed",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~speedAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<TestMemoryLeak *>(dev))->read_speed(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<TestMemoryLeak *>(dev))->write_speed(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<TestMemoryLeak *>(dev))->is_speed_allowed(ty);}
};

//	Attribute windSpeed class definition
class windSpeedAttrib: public Tango::Attr
{
public:
	windSpeedAttrib():Attr("windSpeed",
			Tango::DEV_DOUBLE, Tango::READ) {};
	~windSpeedAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<TestMemoryLeak *>(dev))->read_windSpeed(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<TestMemoryLeak *>(dev))->is_windSpeed_allowed(ty);}
};


/**
 *	The TestMemoryLeakClass singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  TestMemoryLeakClass : public Tango::DeviceClass
#else
class TestMemoryLeakClass : public Tango::DeviceClass
#endif
{
	/*----- PROTECTED REGION ID(TestMemoryLeakClass::Additionnal DServer data members) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	TestMemoryLeakClass::Additionnal DServer data members

	public:
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
	
		//	Method prototypes
		static TestMemoryLeakClass *init(const char *);
		static TestMemoryLeakClass *instance();
		~TestMemoryLeakClass();
		Tango::DbDatum	get_class_property(string &);
		Tango::DbDatum	get_default_device_property(string &);
		Tango::DbDatum	get_default_class_property(string &);
	
	protected:
		TestMemoryLeakClass(string &);
		static TestMemoryLeakClass *_instance;
		void command_factory();
		void attribute_factory(vector<Tango::Attr *> &);
		void write_class_property();
		void set_default_property();
		void get_class_property();
		string get_cvstag();
		string get_cvsroot();
	
	private:
		void device_factory(const Tango::DevVarStringArray *);
		void create_static_attribute_list(vector<Tango::Attr *> &);
		void erase_dynamic_attributes(const Tango::DevVarStringArray *,vector<Tango::Attr *> &);
		vector<string>	defaultAttList;
		Tango::Attr *get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname);
};

}	//	End of namespace

#endif   //	TestMemoryLeak_H
